package it.unibo.stradivarius.activitylifecycle;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;


/* Here we explicitly choose to use the raw Activity class */
public class MainActivity extends Activity {

    int counter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.d("LAM","ON CREATE");
        Toast.makeText(this, "CREATED", Toast.LENGTH_SHORT).show();

        counter = 0;
        setContentView(R.layout.activity_main);

        Button increaseButton = findViewById(R.id.button_increase);
        increaseButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                counter++;
                updateCounter();
                Toast.makeText(getApplicationContext(), "CLICKED", Toast.LENGTH_SHORT).show();
            }
        });

        Button exitButton = findViewById(R.id.button_exit);
        exitButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();  // Invokes the onDestroy() intentionally
            }
        });

    }

    @Override
    protected void onStart(){
        super.onStart();
        Log.d("LAM","ON START");
        Toast.makeText(this, "STARTED", Toast.LENGTH_SHORT).show();
    }

    @Override
    protected void onRestart() {
        super.onRestart();
        Log.d("LAM","ON RESTART");
        Toast.makeText(this, "RESTARTED", Toast.LENGTH_SHORT).show();
    }

    @Override
    protected void onResume(){
        super.onResume();
        Log.d("LAM","ON RESUME");
        Toast.makeText(this, "RESUMED", Toast.LENGTH_SHORT).show();
        updateCounter();
    }

    @Override
    protected void onPause(){
        super.onPause();
        Log.d("LAM","ON PAUSE");
        Toast.makeText(this, "PAUSED", Toast.LENGTH_SHORT).show();
    }

    @Override
    protected void onStop(){
        super.onStop();
        Log.d("LAM","ON STOP");
        Toast.makeText(this, "STOPPED", Toast.LENGTH_SHORT).show();
    }

    @Override
    protected void onDestroy(){
        super.onDestroy();
        Log.d("LAM","ON DESTROY");
        Toast.makeText(this, "DESTROYED", Toast.LENGTH_SHORT).show();
    }

    /* Called when activity is destroyed/stopped */
    @Override
    protected void onSaveInstanceState(Bundle outState){
        Log.d("LAM", "ON SAVE INSTANCE STATE");

        outState.putInt("Count", counter);
        super.onSaveInstanceState(outState);
    }

    @Override
    protected void onRestoreInstanceState(Bundle inState) {
        super.onRestoreInstanceState(inState);

        Log.d("LAM", "ON RESTORE INSTANCE STATE");

        counter = inState.getInt("Count");
    }

    void updateCounter(){
        TextView TW = findViewById(R.id.counter);
        TW.setText(String.valueOf(counter));
    }
}
